<template lang="pug">
.control.is-expanded( :class='{ "has-icons-left": pending }' )
	.select( v-if='brands.length' )
		select( v-model='value' )
			option( v-if='!modelValue' value="" disabled :selected='!modelValue' ) Выберите бренд
			option(
				v-for='(brand, i) in brands' :key='i'
				:value='brand' ) {{ brand.name }}
	span.icon.is-left.has-text-primary( v-if='pending' )
		i.fa-solid.fa-spinner.fa-pulse
</template>

<script setup>
	import { useBrandStore } from "@/stores/brand"
	import { ref, computed, onMounted } from "vue"

	const bs = useBrandStore()

	const props = defineProps({
		modelValue: Object
	})
	const emit = defineEmits([ "update:modelValue" ])

	const brands = ref([])
	const pending = computed(() => bs.pending)

	const value = computed({
		get() {
			return props.modelValue
		},
		set(val) {
			emit("update:modelValue", val)
		}
	})

	const fetch = async () => {
		brands.value = await bs.getAllBrands()
	}

	onMounted(async () => {
		await fetch()
	})
</script>

<style lang="scss"></style>